/**********************************************************************\

File:		BoxOut wipe.c

Purpose:	Graphic effect from offscreen bitmap to main window (on
			screen).  See comments below for more description.


Jotto ][ -=- a simple word game, revisited
Copyright (C) 1993 Mark Pilgrim

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"
#include "wipe dispatch.h"

#define		BOXES	50	/* increase this for a finer grained but more timely effect */
#define CorrectTime 1

void BoxOutWipe(GrafPtr sourceGrafPtr, GrafPtr destGrafPtr, short theWindowHeight, short theWindowWidth)
{
	Rect	theRect;
	short		cenx, ceny;
	short		boxnum;
	
	/* change this as appropriate for the source and destination bounds */
	cenx = theWindowWidth / 2;
	ceny = theWindowHeight / 2;
	
	for(boxnum = 0; boxnum <= BOXES; boxnum++)
	{
		StartTiming();
		
		/* this is not the most efficient method, but the overhead of the
		multiplies and the redundant copying is hidden by the timing mechanism */
		theRect.left = cenx - ((boxnum * cenx) / BOXES);
		theRect.right = cenx + ((boxnum * cenx) / BOXES);
		theRect.top = ceny - ((boxnum * ceny) / BOXES);
		theRect.bottom = ceny + ((boxnum * ceny) / BOXES);
		
		CopyBits(&(sourceGrafPtr->portBits), &(destGrafPtr->portBits),
				&theRect, &theRect, 0, 0L);
		TimeCorrection(CorrectTime);
	}
}