
#include "Interface-Bottlenecks.h"
#include "Interface-Effect.h"
#include <Memory.h>
#include "gGlobals.h"

pascal void StretchBits(BitMap *srcBits, BitMap* dstBits,
							Rect *srcRect, Rect *dstRect, short mode, RgnHandle maskRgn)
{
	CopyBits(srcBits,dstBits,srcRect,dstRect,mode,maskRgn);
}

 pascal void DistortPolygon(GWorldPtr src, GWorldPtr dest, Rect *srcbox, Point *dstpts)
{


}
 pascal void PolyToPoly(GWorldPtr src, GWorldPtr dest, Point *srcpts, Point *dstpts)
{


}

 pascal void AudStretch(Ptr src, long srclen, Ptr dest, long destlen, short flags)
{


}

 pascal void AudMix(Ptr buf1, long v1, Ptr buf2, long v2, Ptr buf3, long v3,
						long width, Ptr dest, short flags)
{


}

/**********
	This routine allocated the Adobe Premiere V2.0 data structures and 
	fill in some of the constants for calling Premiere Effect Modules.
***********/

EffectHandle SetUpAdobeCall(short direction)
{	BottleRec *p;
	EffectHandle theData;
	short direct;
	
	theData = (EffectHandle) NewHandleClear(sizeof(EffectRecord));
	if (theData) {
		p = (BottleRec *) NewPtrClear(sizeof(BottleRec));
		(*theData)->bottleNecks = p;
		p->StretchBits = StretchBits;
		p->count = 1;
		
		(*theData)->total = gNumberSteps;
		(*theData)->part = 1;
		(*theData)->source1 = gWorld;
		(*theData)->source2 = gAltWorld;
		(*theData)->destination = gDstWorld;
		(*theData)->reverse	= gReverse;
		
		switch(direction) {
			case EFFECT_Roll_Left:	direct = bitLeft;	break;
			case EFFECT_Roll_Right:	direct = bitRight;	break;
			case EFFECT_Roll_Down:	direct = bitBottom;	break;
			case EFFECT_Roll_Up:	direct = bitTop;	break;
			
			case EFFECT_Roll_UpperRight:	direct = bitUpperRight;	break;
			case EFFECT_Roll_LowerRight:	direct = bitLowerRight;	break;
			case EFFECT_Roll_LowerLeft:		direct = bitLowerLeft;	break;
			case EFFECT_Roll_UpperLeft:		direct = bitUpperLeft;	break;
			}
		(*theData)->arrowFlags = direct;
		}
		return theData;
}	/* End of Setup */

void CleanUpAdobeCall(EffectHandle theData)
{
	BottleRec *p;
	
	if (theData) {
		if ((*theData)->bottleNecks) DisposePtr((*theData)->bottleNecks);
		DisposHandle(theData);
	}	
}	/* End of () */

short AdobeStageCall(long stageNum, EffectHandle theData)
{
	(*theData)->part = stageNum;
	return xEffectWipe(esExecute,  theData);	

}
