/*
	File:		QuickDraw Movies Library.h

	Copyright:	 1991 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1+>	11/26/91	dvb		Use the DSG versions of quicktime includes.
		 <1>	  8/7/91	dvb		first checked in

	To Do:
*/

/*
 * file: QuickDraw Movies Library.h
 *
 * started 18 April 1991
 * david van brink
 *
 * Some routines to make it a snap! to make qd movies.
 *
 */
 

#ifndef _QuickDrawMoviesLibrary_
#define _QuickDrawMoviesLibrary_

#include <Movies.h>
#include <ImageCompression.h>

/*-----------------------------
	Structures
-----------------------------*/

typedef struct
	{
	long videoTag;
	long compressionType;
	CodecQ compressionQuality;
	CodecQ temporalQuality;
	long keyFrameRate;
	long sequenceID;
	ImageDescription **imageDescriptionH;

	Movie movie;
	Track track;
	Media media;

	short resourceRefNum;
	FSSpec movieDataSpec;
	GWorldPtr gWorldPtr;
	PixMapHandle pixMapH;	/* constructed replica of viewDevice */
	GWorldPtr previousGWorld;
	PixMapHandle previousPixMapH;
	Handle compressedFrameBitsH;		/* a buffer to compress into */
	Rect sourceRect;
	long time;
	} MovieRecorder;

/*-----------------------------
	Routines
-----------------------------*/

void InitializeMovieRecorder(MovieRecorder *mr,GWorldPtr gw,unsigned char *fileName,long frameRate,
		long compressionType,long compressionQuality);
void AddMovieRecorderFrame(MovieRecorder *);
void TerminateMovieRecorder(MovieRecorder *);

#endif _QuickDrawMoviesLibrary_
