/**********************************************************************\

File:		v error.c

Purpose:	This module handles displaying error messages specific to
			Voyeur.


Voyeur -- a no-frills file viewer
Copyright 1993-4, Mark Pilgrim

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "v error.h"
#include "program globals.h"
#include "msg dialogs.h"
#include "msg environment.h"

NMRec			gMyNotification;
int				gPendingResultCode;

void HandleError(int resultCode)
{
	Str255			tempStr;
	Handle			myResHand;
	
	if ((resultCode==userCancelErr) || (resultCode==allsWell)) return;
	
	gWhichFile=gLastFile;
	if (gIsInBackground)
	{
		if (gHasNotificationManager)
		{
			myResHand=GetResource('SICN', 1234);
			gMyNotification.qType=nmType;
			gMyNotification.nmMark=1;
			gMyNotification.nmIcon=myResHand;
			gMyNotification.nmSound=(Handle)-1L;
			gMyNotification.nmStr=0L;
			gMyNotification.nmResp=0L;
			gMyNotification.nmRefCon=0L;
			NMInstall(&gMyNotification);
		}
		gPendingResultCode=resultCode;
	}
	else
	{
		GetIndString(tempStr, 129, resultCode);
		ParamText(tempStr, "\p", "\p", "\p");
		switch (resultCode)
		{
			case hexNotFoundErr:
				ParamText("\pThe hex value $", gFindHexString, "\p was not found (end of file reached.)","\p");
				PositionDialog('ALRT', prefsErrorAlert);
				StopAlert(prefsErrorAlert, 0L);
				break;
			case asciiNotFoundErr:
				ParamText("\pThe text ",gFindString,"\p was not found (end of file reached).","\p");
				PositionDialog('ALRT', prefsErrorAlert);
				StopAlert(prefsErrorAlert, 0L);
				break;
			default:
				PositionDialog('ALRT', generalAlert);
				StopAlert(generalAlert, 0L);
				break;
		}
	}
}
