/* #include files */

#include "A4Stuff.h"
#include "SetupA4.h"
#include "TestGlobals.h"

/* some globals local to this file */

long	gOtherLong;
short	gOtherShort;
char	gOtherChar;

/* InitGlobals */
/* This function must be called at a time when we KNOW a4 to be valid */
/* It is also called to force this segment to load */

void InitGlobals(long otherLong, short otherShort, char otherChar)
{
	long oldA4;
	
	#ifdef USE_DEBUGGER_CALLS
		Debugger();
	#endif
	
	/* set up our A4 context for _this file_ */
	oldA4 = SetCurrentA4();
	RememberA4();

	/* initialize the globals in _this file_ */
	gOtherLong = otherLong;
	gOtherShort = otherShort;
	gOtherChar = otherChar;

	/* restore the a4 world */
	SetA4(oldA4);
}

/* TestGlobals */
/* This function can be called anytime and will set up a4 properly */

void TestGlobals(void)
{
	long oldA4;
	
	#ifdef USE_DEBUGGER_CALLS
		Debugger();
	#endif

	/* use the global data in _this file_ */
	oldA4 = SetUpA4();
	
	/* verify the globals in _this file_ */
	if (gOtherLong != kLongValue) SysBeep(0);
	if (gOtherShort != kShortValue) SysBeep(0);
	if (gOtherChar != kCharValue) SysBeep(0);
	
	/* restore the a4 world */
	RestoreA4(oldA4);
}